"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _draftJs = require("draft-js");

var _immutable = require("immutable");

var insertBlock = function insertBlock(direction, editorState, targetBlock, newBlockType) {
  var selection = editorState.getSelection();
  var contentState = editorState.getCurrentContent();
  var currentBlock = targetBlock || contentState.getBlockForKey(selection.getEndKey());
  var blockMap = contentState.getBlockMap(); // Split the blocks

  var blocksBefore = blockMap.toSeq().takeUntil(function (v) {
    return v === currentBlock;
  });
  var blocksAfter = blockMap.toSeq().skipUntil(function (v) {
    return v === currentBlock;
  }).rest();
  var newBlockKey = (0, _draftJs.genKey)();
  var newBlocks = direction === 'before' ? [[newBlockKey, new _draftJs.ContentBlock({
    key: newBlockKey,
    type: newBlockType,
    text: '',
    characterList: (0, _immutable.List)()
  })], [currentBlock.getKey(), currentBlock]] : [[currentBlock.getKey(), currentBlock], [newBlockKey, new _draftJs.ContentBlock({
    key: newBlockKey,
    type: newBlockType,
    text: '',
    characterList: (0, _immutable.List)()
  })]];
  var newBlockMap = blocksBefore.concat(newBlocks, blocksAfter).toOrderedMap();
  var newContentState = contentState.merge({
    blockMap: newBlockMap,
    selectionBefore: selection,
    selectionAfter: selection
  });
  return _draftJs.EditorState.push(editorState, newContentState, 'insert-fragment');
};

var _default = insertBlock;
exports["default"] = _default;